/**
 * The test class NESLTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class NESLTest extends junit.framework.TestCase
{
    private StringList list0;
    private StringList list1;
    private NESL list2;
    private StringList bigList;
    /**
     * Default constructor for test class NESLTest
     */
    public NESLTest()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
        this.list0 = new ESL();
        this.list1 = new NESL("Crispin", this.list0);
        this.list2 = new NESL("Jake", this.list1);
        this.bigList = new NESL("a", new NESL("b", new NESL("c", new NESL("d", new ESL()))));
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }

    public void testBasics ()
    {
    this.assertEquals("Crispin",((NESL)list1).getFirst());
    this.assertEquals("Jake", list2.getFirst());
    this.assertEquals(list1,list2.getRest());
    this.assertEquals(list0,((NESL)list1).getRest());
    }

    public void testIsEmpty() {
        this.assertTrue(list0.isEmpty());
        this.assertFalse (list1.isEmpty());
        this.assertFalse (list2.isEmpty());
    }
    
    public void testSize()
    {
        this.assertEquals (0, list0.size());
        this.assertEquals (1, list1.size());
        this.assertEquals (2, list2.size());
        this.assertEquals (4, bigList.size());
    }
}
