
/**
 * A non-empty list of strings.
 * 
 * @version 1
 */
public class NESL implements StringList
{
    // instance variables
    private String first;
    private StringList rest;

    /**
     * Constructor for objects of class NESL
     * @param first   the first string in the list
     * @param rest   the remaining StringList
     */
    public NESL(String firstArg, StringList restArg)
    {
        // initialise instance variables
        this.first = firstArg;
        this.rest = restArg;
    }
    
    /**
     * getter for first
     * @return the first String
     */
    public String getFirst ()
    {
        return this.first;
    }
    
    /**
     * getter for rest
     * @return all but the first string in the list
     */
    public StringList getRest ()
    {
        return this.rest;
    }
 }
